// BI2MMXBase.h: interface for the CBI2MMXBase class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BI2MMXBASE_H__B7A2C822_5B59_11D2_9653_041ECB000000__INCLUDED_)
#define AFX_BI2MMXBASE_H__B7A2C822_5B59_11D2_9653_041ECB000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CipherBase.h"
#include "AesComm.h"

class CBI2MMXBase : public CCipherBase  
{
public:
	CBI2MMXBase();
	virtual ~CBI2MMXBase();

	virtual int CipherInitial(DWORD dwParam) ;
	virtual int KeyInitial(BYTE *pByte, DWORD nKeySize, DWORD dwParam) ;
	virtual int Encrypt(BYTE *pByte, DWORD nBlockSize) ;
	virtual int Decrypt(BYTE *pByte, DWORD nBlockSize) ;
	virtual int GetBlockSize() ;
	virtual int GetKeySize() ;
	virtual int GetRounds();

protected:

	u4byte   m_key[44];
	DWORD m_KeySize;
    int IsMMX;

	DWORD DWORD_Sub(DWORD A, DWORD B);

};

#endif // !defined(AFX_BI1MMXBASE_H__B7A2C822_5B59_11D2_9653_041ECB000000__INCLUDED_)
