#include <stdio.h>
#include "RC6Base.h"
#include "RC6MMXBase.h"

extern void genKey(BYTE*);
extern void genData(BYTE*);

void main(void){
    BYTE key[16];
    BYTE data1[16];
    BYTE data2[16];
    CRC6Base rc6;
    CRC6MMXBase rc6mmx;

    for(int i=0; i<10000; i++){
        genKey(key);
        genData(data1);
        for(int j=0; j<16; j++) data2[j]=data1[j];

        rc6.CipherInitial(0);
        rc6mmx.CipherInitial(0);

        rc6.KeyInitial(key, 16, 0);
        rc6mmx.KeyInitial(key, 16, 0);

        rc6.Encrypt(data1, 16);
        rc6mmx.Encrypt(data2, 16);
        for(j=0; j<16; j++){
            if(data1[j]!=data2[j]){
                printf("UNEQUAL!!\n");
                return;
            }
        }
/*
        for(j=0; j<16; j++)
            printf("%x ", data1[j]);
        printf("\n");
        for(j=0; j<16; j++)
            printf("%x ", data2[j]);
        printf("\n");
*/
    }
    printf("GOOD\n");
}