// SBase.h: interface for the CSBase class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SBase_H__B7A2C822_5B59_11D2_9653_041ECB000000__INCLUDED_)
#define AFX_SBase_H__B7A2C822_5B59_11D2_9653_041ECB000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CipherBase.h"
#include "AesComm.h"

class CSBase : public CCipherBase  
{
public:
	CSBase();
	virtual ~CSBase();

	virtual int CipherInitial(DWORD dwParam) ;
	virtual int KeyInitial(BYTE *pByte, DWORD nKeySize, DWORD dwParam) ;
	virtual int Encrypt(BYTE *pByte, DWORD nBlockSize) ;
	virtual int Decrypt(BYTE *pByte, DWORD nBlockSize) ;
	virtual int GetBlockSize() ;
	virtual int GetKeySize() ;
	virtual int GetRounds();

protected:

	u4byte   m_key[32];
	DWORD m_KeySize;
    int IsMMX;

};

#endif // !defined(AFX_SBASE_H__B7A2C822_5B59_11D2_9653_041ECB000000__INCLUDED_)
